
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class MyGameOfLife extends Applet implements ActionListener, MouseMotionListener
{
	private Panel panSouthPanel;
	private Button btnRun;
//  private Button btnStop;
	private Button btnNewGame;
 	private Button btnGoToGen;
 	private TextField txtGeneration;
 	private LifeCanvas MyCanvas;
 	private int Generation;
  	private int MouseCounter=0;
  	private int MouseCounter2=0;
	private Label lblGen;
	private Label lblY;
	
 	public void init()
  	{
    	setBackground(Color.lightGray);
	    setLayout(new BorderLayout());
	
	    MyCanvas = new LifeCanvas();
	    MyCanvas.initFeld(100,100,7);
	    MyCanvas.setBackground(Color.WHITE);
		MyCanvas.addMouseMotionListener(this);
	    add(MyCanvas, BorderLayout.CENTER);
	      
	    panSouthPanel = new Panel();

		lblGen = new Label("XXXX");
		panSouthPanel.add(lblGen);

		lblY = new Label("YYYY");
		panSouthPanel.add(lblY);
		
	    btnNewGame = new Button("Randomize");
		btnNewGame.addActionListener(this);
	    panSouthPanel.add(btnNewGame);
	
		btnRun = new Button("Next Generation");
		btnRun.addActionListener(this);
	    panSouthPanel.add(btnRun);
	    
	    txtGeneration = new TextField("0");
	    panSouthPanel.add(txtGeneration);
	
		btnGoToGen = new Button("Generations forward");
		btnGoToGen.addActionListener(this);
		panSouthPanel.add(btnGoToGen);
		
	    add(panSouthPanel, BorderLayout.SOUTH);
	    
	    MyCanvas.repaint();
	}

	public void mouseDragged(MouseEvent evt)
	{
		int KoordX = evt.getX() / MyCanvas.getSizeFactor();
		int KoordY = evt.getY() / MyCanvas.getSizeFactor();

		lblGen.setText(String.valueOf(KoordX));
		lblY.setText(String.valueOf(KoordY));

		if (!MyCanvas.getCellStatus(KoordX, KoordY))
		{
			MyCanvas.setCellStatus(KoordX, KoordY, true);
			MyCanvas.commitChanges();
			MyCanvas.repaint();
		}
	}

	public void mouseMoved(MouseEvent evt)
	{
		//MouseCounter2++;
		//lblGen.setText(String.valueOf(evt.getX()));
		//lblY.setText(String.valueOf(evt.getY()));
	}
	
	public void actionPerformed(ActionEvent evt)
  	{
		String Command = evt.getActionCommand();
	       
	    if (Command.equals("Next Generation"))
	    {
//	    	GameRuns = true;
			MyCanvas.move();
			MyCanvas.repaint();
				
	    }
	    else if (Command.equals("Randomize"))
	    {
	    	randomize();
	        MyCanvas.repaint();
	    }
		else if (Command.equals("Generations forward"))
		{
			int i;
	
			for (i=1; i<(Integer.valueOf(txtGeneration.getText()).intValue()); i++)
			{
				MyCanvas.move();
			}
			MyCanvas.repaint();
		}
	}
    
    
	private void randomize()
	{
    	double Rand;
		
    	for(int i = 0; i < MyCanvas.getWidth(); i++)
    	{
        	for(int j = 0; j < MyCanvas.getHeight(); j++)
        	{
            	Rand = (Math.random() * 2);
	            if (Rand>1.85)
	            {
	            	MyCanvas.setCellStatus(i, j, true);
	            }
	            else
	            {
	                MyCanvas.setCellStatus(i,j, false);
	            } 
        	}
		
    	}
		MyCanvas.commitChanges();
		MyCanvas.repaint();
	}
}
    

    